// TAIL  //////////////////////////////////////////////////////////////////


function Tail(tLength, tTail, tC1, tC2, tempStripeLength, tempTStripeLength, flip, strikeAngle){
	var tail = [];
	var tailClone = [];
	var tStripeLength = 5;
	var tailG = new PVector(0,1);
	var tailWaveAngle = 0;
	var stripeLength = tempStripeLength;
	var ang = 0;
	
	var c1 = tC1;
	var c2 = tC2;
	
	var remove = false;
	
	var isBright = true;
	setTimeout(function(){isBright = false;},100);
	
	if(flip == 0){ // switch colours
		c2 = tC1;
		c1 = tC2;
	}
	
	var stopHeight = canvas.width + (tStripeLength * 30);

	
	if(tTail[tLength - 1] != null){
		for(var i = 0; i < tTail.length - tLength + 1; i++){
			tail[i] = new PVector(0,0);
			tail[i].setXAndY(tTail[i+tLength-1].x,tTail[i+tLength-1].y);
			
			tail[i].add(strikeAngle);
			strikeAngle.limit(strikeAngle.mag()*0.8);
			
			tailClone[i] = new PVector(0,0);
		}
	}
	else{
		for(var i = 0; i < tTail.length - tLength; i++){
			tail[i] = new PVector(0,0);
			tail[i].setXAndY(tTail[i+tLength].x,tTail[i+tLength].y);
			
			tailClone[i] = new PVector(0,0);
		}
	}
	
	tail[0].add(strikeAngle);
	
	
	this.update = function(){
		if(tail[0].y < stopHeight){ // <--------- make this better
			var tOther = new PVector(0,0);
			var tWave = new PVector(1,0);
		
			// tail wave bit (may need improvement)
			//tWave.rotate(ang - Math.PI);
			tWave.limit((Math.sin(tailWaveAngle)));
		
			tailWaveAngle += 0.05;
			if(tailWaveAngle > 2*Math.PI){
				tailWaveAngle -= 2*Math.PI;
			}
			///// end of twb
			
			tailG.limit(1);
			
			tail[0].add(tailG);
			tail[0].add(tWave);
			
			tailG.limit(0.5);
		
			for(var i = 1; i < tail.length; i++){
				tOther.makeEqualTo(tail[i]);
				tOther.add(tailG);
			
				// tail wave bit may need improvement
				tWave.limit((((1+Math.cos(tailWaveAngle))/2)/i)*5);
				//tOther.add(tWave);
				///// end of twb
		
				distB = dist(tOther,tail[i-1]);
		
				if(distB > tStripeLength){
					tail[i].movePointBetween(tOther,tail[i-1],1-(tStripeLength/distB));
				}
			}
			
			this.updateClone();
		}
		else{
			remove = true;
		}
	}
	
	this.updateClone = function(){
		var offset = canvas.width;
		
		if(tail[0].x < canvas.width/2){
			offset = -offset;
		}
		
		for(var i = 0; i < tail.length; i++){
			tailClone[i].setXAndY(tail[i].x - offset, tail[i].y);
		}
	}
	
	this.display = function(){
		// display tail    	
      	var alt = 0;
      	for(var i = 0; i < tail.length-stripeLength; i+=stripeLength){	
			context.beginPath();
			context.moveTo(tail[i].x,tail[i].y);
			
			for(var j = i+1; j < i+stripeLength+1; j++){
				context.lineTo(tail[j].x,tail[j].y);
			}
			
			if(isBright){
				context.strokeStyle = 'rgba(255,255,225,1)';
				context.lineWidth = 3;
				context.stroke();
			}
			else if(alt%2 == 0){
				context.strokeStyle = c1;
				context.lineWidth = 3;
				context.stroke();
			}
			else{
				context.strokeStyle = c2;
				context.lineWidth = 3;
				context.stroke();
			}
			alt++;	
      	}
      	
      	alt = 0;
      	for(var i = 0; i < tail.length-stripeLength; i+=stripeLength){	
			context.beginPath();
			context.moveTo(tailClone[i].x,tailClone[i].y);
			
			for(var j = i+1; j < i+stripeLength+1; j++){
				context.lineTo(tailClone[j].x,tailClone[j].y);
			}
		
			if(isBright){
				context.strokeStyle = 'rgba(255,255,225,1)';
				context.lineWidth = 3;
				context.stroke();
			}
			else if(alt%2 == 0){
				context.strokeStyle = c1;
				context.lineWidth = 3;
				context.stroke();
			}
			else{
				context.strokeStyle = c2;
				context.lineWidth = 3;
				context.stroke();
			}
			alt++;	
      	}
	}
	
	this.getRemove = function(){
		return remove;
	}
	
	
}